
#include <iostream>

#include "pairpartition.h"

void test_pp(size_t class_count) {
	std::cout << "# Test pairpartition, class_count = " << class_count
		<< std::endl;
	voc::pairpartition pp(class_count);

	size_t sc = pp.number_of_sets();
	std::cout << "Number of partition sets is " << sc << std::endl;

	for (size_t si = 0; si < sc; ++si) {
		auto const& set = pp.get_set(si);
		std::cout << "Set " << (si+1) << ": {";
		for (size_t pi = 0; pi < set.size(); ++pi) {
			std::cout << " (" << set[pi].first << "," << set[pi].second << "),";
		}
		std::cout << " }" << std::endl;
	}
	std::cout << std::endl;
}

int main(int argc, char* argv[]) {
	test_pp(2);
	test_pp(3);
	test_pp(4);
	test_pp(21);
}

